-- Aufgabe 1
data Season = Spring | Summer | Automn | Winter
 deriving (Eq, Ord, Enum, Show)

data Month = January | February | March | April | May | June | July | August | September | October | November | December
 deriving (Eq, Ord, Enum, Show)

toSeason :: Month -> Season
toSeason January = Winter
toSeason February = Winter
toSeason March = Spring
toSeason April = Spring
toSeason May = Spring
toSeason June = Summer
toSeason July = Summer
toSeason August = Summer
toSeason September = Automn
toSeason October = Automn
toSeason November = Automn
toSeason December = Winter

-- Aufgabe 2
data Shape = Circle Float | Rectangle Float Float
-- a)
lengthOfEdge :: Shape -> Float
lengthOfEdge (Circle r) = 2*pi*r
lengthOfEdge (Rectangle a b) = 2*(a+b)

-- b)
instance Show Shape where
  show (Rectangle a b) = take (round a) (repeat ('*')) ++ "\n" ++ concat (take ((round b)-2) hilf) ++ take (round a) (repeat ('*'))
    where hilf = repeat ("*" ++ take ((round a)-2) (repeat (' ')) ++ "*\n")

ausgabe a b = putStr (show (Rectangle a b))

-- Aufgabe 3
-- a)
data EAA = Atom Float | Add EAA EAA | Sub EAA EAA | Mult EAA EAA | Div EAA EAA | Min EAA

a,b :: EAA  -- Beispielausdrcke
a = Sub (Atom 3) (Add (Atom 4) (Atom 9)) -- a = 3-(4+9) 
b = Sub (Add (Atom 4) (Atom 9)) (Atom 3) -- b = (4+9)-3

value :: EAA -> Float
value (Atom z) = z
value (Add a1 a2) = value a1 + value a2
value (Sub a1 a2) = value a1 - value a2
value (Mult a1 a2) = value a1 * value a2
value (Div a1 a2) = value a1 / value a2
value (Min a) = - (value a)

instance Show EAA where 
   show (Atom z) = show z
   show (Add a1 a2) = "( " ++ show a1 ++ " + " ++ show a2 ++ " )"
   show (Sub a1 a2) = "( " ++ show a1 ++ " - " ++ show a2 ++ " )"
   show (Mult a1 a2) = "(" ++ show a1 ++ " * " ++ show a2 ++ " )"
   show (Div a1 a2) = "(" ++ show a1 ++ " / " ++ show a2 ++ " )"
   show (Min a) = "( - " ++ show a ++ " )" 

-- Stapelmaschine zur Auswertung von EAA's

data Com = PUSH Float | ADD | SUB | MULT | DIV | MIN -- Befehlssatz der Stapelmaschine
   deriving Show

type Prog = [Com]  -- Programme der Stapelmaschine

makeProg :: EAA -> Prog -- bersetzer
makeProg(Atom z) = [PUSH z]
makeProg (Add a1 a2) = (makeProg a1) ++ (makeProg a2) ++ [ADD]
makeProg (Sub a1 a2) = (makeProg a1) ++ (makeProg a2) ++ [SUB]
makeProg (Mult a1 a2) = (makeProg a1) ++ (makeProg a2) ++ [MULT]
makeProg (Div a1 a2) = (makeProg a1) ++ (makeProg a2) ++ [DIV]
makeProg (Min a) = (makeProg a) ++ [MIN]

type Stack = [Float] -- Datenspeicher der Stapelmaschine

data StackMachine = State Prog Stack -- die Stapelmaschine hat ein Programm- und ein Datenspeicher
   deriving Show

step :: StackMachine -> StackMachine -- Zustandsberfhrungsfunktion
step (State (c:cs) s) = State cs (apply c s)

apply :: Com -> Stack -> Stack -- Befehlsausfhrung
apply (PUSH z) s = z:s
apply ADD (z1:z2:s) = (z2+z1):s
apply SUB (z1:z2:s) = (z2-z1):s
apply MULT (z1:z2:s) = (z2*z1):s
apply DIV (z1:z2:s) = (z2/z1):s
apply MIN (z:s) = (-z):s

load :: Prog -> StackMachine -- Laden eines Programms
load p = State p []

run :: StackMachine -> StackMachine -- Ausfhrung eines Programms
run (State [] s) = State [] s
run sm = run (step sm)

dump :: StackMachine -> IO() -- Ausdrucken eines Programmlaufs
dump (State [] s) = putStr (show (State [] s))
dump sm = do putStr (show sm)
             putStr "\n"
             dump (step sm)

{- Der Wert eines Ausdrucks a kann berechnet werden, indem er in   
   ein Programm der Stapelmaschine bersetzt wird, das geladen und 
   auf der Stapelmaschine ausgefhrt wird. 
   Anschlieend liegt der Wert auf dem Keller.
-}

eval :: EAA -> Float
eval = readTop . run . load . makeProg

readTop :: StackMachine -> Float
readTop (State p (z:s)) = z

