-- 8. Uebungszettel

import Char
-- Aufgabe 1

-- Sortierverfahren, zunchst fr ganze Zahlen

-- a) Sortieren durch Einfgen - Insertion sort
-- aufsteigend
iSort :: [Int] -> [Int] 
iSort [] = []
iSort (x:xs) = insert x (iSort xs)

insert :: Int -> [Int] -> [Int] 
insert x [] = [x]
insert x (y:ys) 
	| x <= y    = x:y:ys
	| otherwise = y : insert x ys

-- absteigend ohne doppelte Elemente
iSort2 :: [Int]->[Int]
iSort2 [] = []
iSort2 (x:xs) = insert2 x (iSort2 xs)
  
insert2 :: Int -> [Int] -> [Int] 
insert2 x [] = [x]
insert2 x (y:ys) 
	| x > y    = x:y:ys
  | x == y    = x:ys
	| otherwise = y:insert2 x ys 

-- b) Sortieren durch Mischen - Merge sort
-- aufsteigend
mSort :: [Int] -> [Int] 
mSort [] = []
mSort [x] = [x]
mSort xs = merge (mSort left) (mSort right)
           where (left,right) = splitAt (length xs `div` 2) xs

merge :: [Int] -> [Int] -> [Int]
merge [] xs = xs
merge xs [] = xs
merge (x:xs) (y:ys) 
	| x <= y    = x : merge xs (y:ys)
	| otherwise = y : merge (x:xs) ys

-- absteigend
mSort2 :: [Int] -> [Int] 
mSort2 [] = []
mSort2 [x] = [x]
mSort2 xs = merge2 (mSort2 left) (mSort2 right)
           where (left,right) = splitAt (length xs `div` 2) xs

merge2 :: [Int] -> [Int] -> [Int]
merge2 [] xs = xs
merge2 xs [] = xs
merge2 (x:xs) (y:ys) 
	| x >= y    = x : merge2 xs (y:ys)
	| otherwise = y : merge2 (x:xs) ys

-- c) Sortieren nach Tony Hoare - Quick Sort
-- aufsteigend
qSort :: [Int] -> [Int] 
qSort [] = []
qSort (x:xs) = qSort [ y | y <- xs, y <= x ] ++ [x] ++
               qSort [ y | y <- xs, y >  x ]

-- absteigend
qSort2 :: [Int] -> [Int] 
qSort2 [] = []
qSort2 (x:xs) = qSort2 [ y | y <- xs, y >= x ] ++ [x] ++
               qSort2 [ y | y <- xs, y <  x ]
-- Testen von Sortierverfahren

-- a) Vereinbare einige Testlisten l1 bis l7
l1,l2,l3,l4,l5, l6, l7 :: [Int]
l1 = []
l2 = [-5]
l3 = [-2,5,76,-6,-4,3]
l4 = [1,2,3,4,5,6,7,8,9]
l5 = [9,8,7,6,5,4,3,2,1]
l6 = [1..1000]
l7 = [1000, 999..1]

-- b) Generiere Zufallszahlen

nextRand :: Int -> Int
nextRand n = (factor * n + inc) `mod` modulus

randomSequence  :: [Int]
randomSequence = iterate nextRand seed -- iterate :: (a -> a) -> a -> [a] aus Prelude

seed, factor, inc, modulus :: Int
seed = 17489
factor = 25173
inc = 13849
modulus = 65536

rN :: Int -> [Int] -- rN n ist eine Liste mit n Zufallszahlen
rN n = take n randomSequence


-----------------------------


-- Ausschnitt aus einem einfachen Textverarbeitungssystem

-- Ziel: Ein Text soll in Zeilen gleicher Lnge transformiert werden.

beispielText :: String
beispielText = "  Das   ist	 der \n  erste Versuch, den  wir   heute   machen \n wollen.  Und du bist \n ein \n gaaaaaaaaaanz \t fettes ..     ARSCHLOCH!!! \t Das bis \n du n&auml;mlich!!"
lineLen :: Int -- gewnschte Zeilenlnge
lineLen = 30

-- ursprnglich vorhandene Leerzeichen, Tabulatoren und Zeilenumbrche sollen entfernt werden.

whiteSpaces :: [Char]
whiteSpaces = [' ', '\t', '\n']

isWhite :: Char -> Bool
isWhite c = c `elem` whiteSpaces

-- Definition: Ein Wort ist eine Zeichenfolge, die keine whiteSpaces enthlt.

type Word = String

-- splitWords generiert die Wortfolge aus einem Text

splitWords :: String -> [Word]
splitWords [] = []
splitWords t = getWord t': splitWords (dropWord t')             
               where t' = dropWhile isWhite t


-- getWord extrahiert das erste Wort und dropWord entfernt es aus einem Text

getWord :: String -> Word
getWord [] = []
getWord (c:cs) = if isWhite c then [] else c : getWord cs

dropWord :: String -> String
dropWord [] = []
dropWord (c:cs) = if isWhite c then cs else dropWord cs

-- Eine Zeile ist eine Wortfolge

type Line = [Word]

-- splitLines generiert eine Zeilenfolge aus einer Wortfolge

splitLines :: [Word] -> [Line]
splitLines [] = []
splitLines ws = getline lineLen ws : splitLines (dropLine lineLen ws)

getline :: Int -> [Word] -> Line -- generiert die erste Zeile
getline _ [] = []
getline len (w:ws) 
	| length w <= len  = w : restOfLine
	| otherwise        = []
          where newlen = len - (length w + 1)
                restOfLine = getline newlen ws

dropLine :: Int -> [Word] -> [Word] -- entfernt die erste Zeile
dropLine _ [] = []
dropLine len (w:ws) 
	| length w <= len  = restOfWords
	| otherwise        = w:ws
          where newlen = len - (length w + 1)
                restOfWords = dropLine newlen ws


-- layout erzeugt Zieltext aus einer Zeilenfolge
layout :: [Line] -> String
layout ls = joinLines (map joinWords ls)

joinWords :: [Word] -> String
joinWords [] = []
joinWords (w:[]) = w
joinWords (w:ws) = w ++ " " ++ joinWords ws

joinWordsCentred :: [Word] -> String
joinWordsCentred [] = []
joinWordsCentred ws
  | diff == 0 = joinWords ws
  | even diff = take (diff `div` 2) (repeat (' ')) ++ joinWords ws ++ take (diff `div` 2) (repeat (' '))
  | otherwise = take (diff `div` 2) (repeat (' ')) ++ joinWords ws ++ take (diff `div` 2 +1) (repeat (' '))
  where currentlength = length (joinWords ws)
        diff = lineLen - currentlength

joinWordsBlocked :: [Word] -> String
joinWordsBlocked [] = []
joinWordsBlocked (w:ws)
  | diff == 0 = joinWords ws
  | even diff = (joinWords ([word ++ (take (anzspacesword-1) (repeat (' '))) | word<- (w:ws)]))
  | otherwise = (w ++ (take (rest) (repeat (' '))) ++ joinWords ([word ++ (take (anzspacesword-1) (repeat (' '))) | word<- ws]))
  where currentlength = length (joinWords ws)
        anzwords = length (w:ws) -1
        diff = lineLen - currentlength
        anzspacesword = diff `div` anzwords
        rest = diff `rem` anzwords

joinLines :: [String] -> String
joinLines [] = []
joinLines (l:ls) = l ++ "\n" ++ joinLines ls

layoutBlocked :: [Line] -> String
layoutBlocked ls = joinLines (map joinWordsBlocked ls)

layoutCentred :: [Line] -> String
layoutCentred ls = joinLines (map joinWordsCentred ls)

-- putInLines transformiert Quelltext gem Spezifkation in Zieltext

putInLines :: String -> String
putInLines = layout . splitLines . splitWords

putInBlockedLines :: String -> String
putInBlockedLines = layoutBlocked . splitLines . splitWords

putInCentredLines :: String -> String
putInCentredLines = layoutCentred . splitLines . splitWords

test :: IO()  -- Ein erster Test
test = putStr (putInLines beispielText)
test2 = putStr (putInBlockedLines beispielText)
test3 = putStr (putInCentredLines beispielText)


---------------------------------------------

-- Aufgabe 3
-- Testet, ob ein String ein Palindrom ist
isPalin:: String -> Bool
isPalin s 
  | map toLower (filter (isAlpha) s) == map toLower (reverse (filter (isAlpha) s)) = True
  | otherwise = False